%define _disable_ld_no_undefined 1
%define _disable_lto 1

%define _localstatedir 	 /var/run

%define mod_gss_version 1.3.9
%define mod_autohost_version 0.7
%define mod_case_version 0.9.1
%define mod_vroot_version 0.9.9
%define mod_geoip2_version 0.1

Summary:	Professional FTP Server
Name:		proftpd
Version:	1.3.8a
Release:	%mkrel 1
License:	GPL
Group:		System/Servers
URL:		http://proftpd.org/
Source0:	https://github.com/proftpd/proftpd/releases/download/%{version}/%{name}-%{version}.tar.gz
Source1:	proftpd.logrotate
Source2: 	proftpd.xinetd
Source3:	proftpd.init
Source4:	proftpd.service
Source5:	basic.conf
Source7:	welcome.msg
Source32:	32_mod_shaper.conf
Source33:   mod_tls.conf
Source34:   mod_ban.conf
Source35:   mod_ban.module
Source37:   mod_gss.module
Source36:   proftpd.sysconfig
Source100:	http://prdownloads.sourceforge.net/gssmod/mod_gss-%{mod_gss_version}.tar.gz
Source102:	http://www.castaglia.org/proftpd/modules/proftpd-mod-autohost-%{mod_autohost_version}.tar.xz
Source103:	http://www.castaglia.org/proftpd/modules/proftpd-mod-case-%{mod_case_version}.tar.xz
Source108:	http://www.castaglia.org/proftpd/modules/proftpd-mod-vroot-%{mod_vroot_version}.tar.xz
Source109:	http://www.castaglia.org/proftpd/modules/proftpd-mod-geoip2-%{mod_geoip2_version}.tar.xz
Source200:	anonymous.conf

Patch0:		proftpd-1.3.4b-mdv-xferstats_logfile_location.diff
Patch2:		proftpd-1.3.4b-mdv-use-system-auth-instead-of-pam_unix.diff
Patch4:		proftpd-1.3.7-mdv-installfix.diff
Patch7:		proftpd-1.3.4b-mdv-change_pam_name.diff

Requires:	pam
Requires:	setup
Requires(pre):   rpm-helper >= 0.23.5
Requires(post):  rpm-helper >= 0.23.5
Requires(preun): rpm-helper >= 0.23.5
Requires:        perl-Mail-Sendmail
BuildRequires:	%{_lib}cap-devel
BuildRequires:	gettext-devel
BuildRequires:	%{_lib}acl-devel
BuildRequires:	%{_lib}attr-devel
BuildRequires:	%{_lib}sodium-devel
BuildRequires:	krb-devel
BuildRequires:	libtool
BuildRequires:	libtool-devel
BuildRequires:	%{_lib}mariadb-devel
BuildRequires:	ncurses-devel
BuildRequires:	openldap-devel
BuildRequires:  openssl-devel
BuildRequires:	pam-devel
BuildRequires:	pkgconfig
BuildRequires:	postgresql13-devel
BuildRequires:	%{_lib}geoip-devel
BuildRequires:	%{_lib}wrap-devel
BuildRequires:	zlib-devel
BuildRequires:	%{_lib}maxminddb-devel
Provides:	ftpserver

Conflicts:	wu-ftpd
Conflicts:	ncftpd
Conflicts:	beroftpd
Conflicts:	anonftp

%description
ProFTPd is an enhanced FTP server with a focus toward simplicity, security, and
ease of configuration.  It features a very Apache-like configuration syntax,
and a highly customizable server infrastructure, including support for multiple
'virtual' FTP servers, anonymous FTP, and permission-based directory
visibility.

This version supports both standalone and xinetd operation.

%package	devel
Summary:	Development files for ProFTPD
Group:		Development/Libraries

%description	devel
This package contains the development headers for ProFTPD

%package	mod_ctrls_admin
Summary:	Module implementing admin control handlers
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ctrls_admin
This module implements administrative control actions for the ftpdctl program.

%package	mod_ifsession
Summary:	Module supporting conditional per-user/group/class configuration contexts
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ifsession
Module supporting conditional per-user/group/class configuration contexts

%package	mod_ldap
Summary:	LDAP password lookup module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ldap
LDAP password lookup module for ProFTPD

%package	mod_quotatab
Summary:	Module for managing FTP byte/file quotas via centralized tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab
Module for managing FTP byte/file quotas via centralized tables

%package	mod_quotatab_file
Summary:	Sub-module for managing quota data via file-based tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_file
Sub-module for managing quota data via file-based tables

%package	mod_quotatab_ldap
Summary:	Sub-module for obtaining quota information from an LDAP directory
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_ldap
Sub-module for obtaining quota information from an LDAP directory

%package	mod_quotatab_sql
Summary:	Sub-module for managing quota data via SQL-based tables
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_sql
Sub-module for managing quota data via SQL-based tables

%package	mod_quotatab_radius
Summary:	Sub-module for managing quota data via radius
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_quotatab = %{version}-%{release}
Provides:	%{name}-mod_quotatab_driver = %{version}-%{release}

%description	mod_quotatab_radius
Sub-module for managing quota data via radius

%package	mod_radius
Summary:	Module for RADIUS authentication and accounting
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_radius
Module for RADIUS authentication and accounting

%package	mod_ratio
Summary:	Support upload/download ratios
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ratio
Support upload/download ratios

%package	mod_rewrite
Summary:	Module for rewriting FTP commands
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_rewrite
Module for rewriting FTP commands

%package	mod_site_misc
Summary:	Module implementing miscellaneous SITE commands
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_site_misc
Module implementing miscellaneous SITE commands

%package	mod_sql
Summary:	SQL frontend
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description mod_sql
SQL frontend

%package	mod_sql_mysql
Summary:	Support for connecting to MySQL databases
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_sql = %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql_mysql
Support for connecting to MySQL databases

%package	mod_sql_postgres
Summary:	Support for connecting to Postgres databases
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name}-mod_sql = %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql_postgres
Support for connecting to Postgres databases

%package	mod_tls_shmcache
Summary:	Provide an external SSL session cache using shared memory
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_tls_shmcache
This submodule provides a SysV shared memory-based implementation of an external SSL session cache for use by the mod_tls module's TLSSessionCache directive

%package	mod_autohost
Summary:	An autohost module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_autohost
For sites that run a large number of <VirtualHost>s for proftpd, it can be
cumbersome to configure them all in the proftpd.conf file. Adding or removing
virtual server configurations require restarting the daemon, as do changes to
one of the server configurations. The daemon also consumes memory for each
server configuration, and the memory footprint for the daemon process can grow
large for large numbers of servers.

The mod_autohost module allows for server configurations to be configured in
individual files, and for those configuration to be used in an "on demand"
fashion. Rather than loading the configurations into memory when the daemon
starts up, the daemon will check the IP address and port being contacted by a
connecting client, check in the filesystem for a mod_autohost configuration
file for that address/port, dynamically parse the configuration, and insert
the configuration into the session's process space. Thus changes to the
configuration are seen whenever a client connects, without requiring a daemon
restart. The memory footprint is reduced because proftpd, via mod_autohost,
only reads and uses the needed configuration.

%package	mod_case
Summary:	Makes ProFTPD case insensitive
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_case
The mod_case module is designed to help ProFTPD be case-insensitive, for those
sites that may need it (e.g. those that are migrating from a Windows
environment or have mounted Windows filesystems).

mod_case works by performing two checks on the filename used in FTP commands.
First, mod_case will scan the directory to see if there is already a file whose
name exactly matches the given filename. If not, mod_case will scan the
directory again, this time looking for case-insensitive matches. 

%package	mod_gss
Summary:	A Kerberos 5 GSS module for ProFTPD with mod_auth_gss included
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_gss
A Kerberos 5 GSS module for ProFTPD - with mod_auth_gss included

%package	mod_load
Summary:	A module that determines average load for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_load
The code for determining load average on a given system is hairy, to say the
least. Unfortunately, it is necessary to do it this way, as there is no
standard method for extracting such information from the kernel. This module
uses code from GNU's make application, which should function properly. If not,
please contact the author as soon as possible.

%package	mod_shaper
Summary:	A shaping module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_shaper
The mod_shaper module is designed to split overall rates, both download and
upload, for the proftpd daemon among all connected FTP clients, shaping each
session to use only a portion of the overall rate. mod_shaper shapes both
transmitted traffic, e.g. bits being downloaded via the RETR command, and
received traffic, e.g. bits being uploaded via the APPE, STOR, and STOU
commands.

%package	mod_wrap
Summary:	Provides tcpwrapper-like access control rules for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap_driver = %{version}-%{release}
Requires:	tcp_wrappers

%description	mod_wrap
The mod_wrap package  It enables the daemon to use the common tcpwrappers access control library while in standalone mode, and in a very configurable manner. Many programs will automatically add entries in the common allow/deny files, and use of this module will allow a ProFTPD daemon running in standalone mode to adapt as these entries are added. The portsentry program does this, for example: when illegal access is attempted, it will add hosts to the /etc/hosts.deny file. 
Once installed, it highly recommended that the hosts_access (3) and hosts_access(5) man pages be read and understood

%package	mod_wrap2
Summary:	Provides tcpwrapper-like access control rules for ProFTPD while server is running in standalone mode
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap2_driver = %{version}-%{release}

%description	mod_wrap2
The mod_wrap2 package allows the proftpd daemon to prov`find mod_vroot -type f -name "*.h"`ide tcpwrapper-like access control rules while running in standalone mode. It also allows for those access rules to be stored in various formats, such as files (e.g. /etc/hosts.allow and /etc/hosts.deny) or in SQL tables. Note that the mod_wrap2 module does not require or use the standard tcpwrappers libwrap library, and instead implements the same functionality internally.

The most current version of mod_wrap's submodules supports storage of access
table information in various formats:

 o mod_wrap2_file for file-based access tables
 o mod_wrap2_sql for SQL-based access tables

%package	mod_wrap2_file
Summary:	A file-specific driver for the mod_wrap module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap_driver = %{version}-%{release}
Requires:	%{name}-mod_wrap2 >= %{version}-%{release}

%description	mod_wrap2_file
This submodule provides the file-specific "driver" for storing IP/DNS-based
access control information in files.

%package	mod_wrap2_sql
Summary:	A SQL database driver for the mod_wrap module for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Provides:	%{name}-mod_wrap_driver = %{version}-%{release}
Requires:	%{name}-mod_wrap2 >= %{version}-%{release}

%description	mod_wrap2_sql
This submodule provides the SQL database "driver" for storing IP/DNS-based
access control information in SQL tables.

%package	mod_ban
Summary:	Adds dynamic "ban" lists to ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_ban
The mod_ban module is designed to add dynamic "ban" lists to proftpd. A ban
prevents the banned user, host, or class from logging in to the server; it does
not prevent the banned user, host, or class from connecting to the server.
mod_ban is not a firewall. The module also provides automatic bans that are
triggered based on configurable criteria.

%package	mod_vroot
Summary:	Adds virtual chroot capability to ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_vroot
The purpose of this module to is to implement a virtual chroot capability that
does not require root privileges. The mod_vroot module provides this capability
by using ProFTPD's FS API, available as of 1.2.8rc1.

%package	mod_sftp
Summary:	Implements the SSH2 protocol and its SFTP subsystem for ProFTPD
Group:		System/Servers
Requires(post): %{name} = %{version}-%{release}
Requires(preun): %{name} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}

%description	mod_sftp
The mod_sftp module implements the SSH2 protocol and its SFTP subsystem, for
secure file transfer over an SSH2 connection. The mod_sftp module supports:

 o Public key authentication
 o Password authentication (e.g. user authentication via mod_sql, mod_ldap,
   mod_auth_file, mod_auth_unix, mod_auth_pam)
 o SCP support
 o Quotas (via the mod_quotatab module)
 o FIPS support (see Usage section)
 o Throttled transfers (via TransferRate, and/or the mod_shaper module)
 o Blacklisted public keys
 o Configurable traffic analysis protection
 o Passphrase-protected host keys

%package	mod_sftp_pam
Summary:	A module which provides an SSH2 "keyboard-interactive" driver using PAM
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Requires:	%{name}-mod_sftp >= %{version}-%{release}

%description	mod_sftp_pam
The mod_sftp_pam module provides support for the "SSH Keyboard-Interactive
Authentication" RFC (RFC4256).

%package	mod_sftp_sql
Summary:	SQL backend module for retrieving authorized keys
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Requires:	%{name}-mod_sftp >= %{version}-%{release}
Requires:	%{name}-mod_sql >= %{version}-%{release}

%description	mod_sftp_sql
The mod_sftp module for ProFTPD can support different storage formats for its
user- and host-based authorized keys. By default, the mod_sftp module supports
storing authorized keys in flats. This mod_sftp_sql module allows for
authorized SSH keys to be stored in SQL tables.

%package	mod_copy
Summary:	This ProFTPD module implements SITE CPFR and SITE CPTO commands
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Requires:	%{name}-mod_copy >= %{version}-%{release}

%description	mod_copy
The mod_copy module implements SITE CPFR and SITE CPTO commands (analogous to RNFR and RNTO),
which can be used to copy files/directories from one place to another on the server
without having to transfer the data to the client and back

%package	mod_deflate
Summary:	This ProFTPD module is designed to provide support for MODE Z commands
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Requires:	%{name}-mod_deflate >= %{version}-%{release}

%description	mod_deflate
The mod_deflate module is designed to provide support for MODE Z commands,
which allows FTP clients and servers to compress data for transfer.

%package	mod_exec
Summary:	This ProFTPD module can be used to execute external programs or scripts
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Requires:	%{name}-mod_exec >= %{version}-%{release}

%description	mod_exec
The mod_exec module can be used to execute external programs or scripts at various points in the process of handling FTP commands.
By conscious design, the core ProFTPD engine does not and will not execute external programs.
This is a security decision, as it was decided not to allow ProFTPD to serve as a means of compromising a system or disclosing information via bugs in external programs or scripts.
Use of this module allows for such external programs to be executed
and also opens up the server to the mentioned possibilities of compromise or disclosure via those programs.

=========YOU HAVE BEEN WARNED=========
=========USE AT YOUR OWN RISK=========

%package	mod_sql_passwd
Summary:	This ProFTPd module add support for some formats for the passwords stored in SQL databases
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Requires:	%{name}-mod_sql_passwd >= %{version}-%{release}
Requires:	%{name}-mod_sql >= %{version}-%{release}

%description	mod_sql_passwd
Many FTP sites use SQL databases for storing user accounts, including the user name and password.
And while the mod_sql module provides support for some formats for the passwords stored in SQL databases,
many sites have other formats which are not supported by mod_sql.
These other formats often include MD5 or SHA1 passwords, base64-encoded or hex-encoded,
without the prefix which is required by mod_sql's "OpenSSL" SQLAuthType. 

%package	mod_sql_sqlite
Summary:	This ProFTPd module add support for connecting to a SQLite database
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Provides:	%{name}-mod_sql_driver = %{version}-%{release}

%description	mod_sql_sqlite
The mod_sql_sqlite module is designed to let ProFTPD's mod_sql module connect to and use a SQLite database.

%package	mod_geoip2
Summary:	This ProFTPd module uses the GeoIP library from MaxMind
Group:		System/Servers
Requires(post):	%{name} >= %{version}-%{release}
Requires(preun):	%{name} >= %{version}-%{release}
Requires:	%{name} >= %{version}-%{release}
Obsoletes:  %{name}-mod_geoip < %{version}-%{release}
Requires:	%{name}-mod_geoip2 >= %{version}-%{release}

%description	mod_geoip2
The mod_geoip2 module uses the GeoIP library from MaxMind to look up various geographic information for a connecting client:
http://www.maxmind.com/app/c
This information can be used to set access controls for the server.

%prep
%setup -q -n %{name}-%{version}
tar xf %{SOURCE108}
tar xf %{SOURCE100}
tar xf %{SOURCE102}
tar xf %{SOURCE103}
tar xf %{SOURCE109}
mv mod_vroot contrib/mod_vroot

%patch0 -p0 -b .logfile_location
%patch2 -p0 -b .pam
%patch4 -p1 -b .installfix
%patch7 -p0 -b .change_pam_name

# PCLinuxOS config
mkdir -p PCLinuxOS
install -m0644 %{SOURCE1} PCLinuxOS/proftpd.logrotate
install -m0644 %{SOURCE2} PCLinuxOS/proftpd.xinetd
install -m0644 %{SOURCE3} PCLinuxOS/proftpd.init
install -m0644 %{SOURCE4} PCLinuxOS/proftpd.service
install -m0644 %{SOURCE5} PCLinuxOS/basic.conf
install -m0644 %{SOURCE7} PCLinuxOS/welcome.msg
install -m0644 %{SOURCE32} PCLinuxOS/32_mod_shaper.conf

# lib64 fix
perl -pi -e "s|/usr/lib|%{_libdir}|g" PCLinuxOS/basic.conf

# fix includes, instead of a patch
#mysql_mysql
perl -pi -e "s|\<mysql\.h\>|\<mysql\/mysql\.h\>|g" contrib/mod_sql_mysql.c

%build
# Modules to be built as DSO's (excluding mod_ifsession, always specified last)
SMOD1=mod_sql:mod_sql_passwd:mod_sql_mysql:mod_sql_postgres:mod_sql_sqlite:mod_autohost:mod_case:mod_shaper
SMOD2=mod_quotatab:mod_quotatab_file:mod_quotatab_ldap:mod_quotatab_radius:mod_quotatab_sql
SMOD3=mod_ldap:mod_ban:mod_ctrls_admin:mod_load:mod_vroot
SMOD4=mod_radius:mod_ratio:mod_rewrite:mod_site_misc:mod_exec
SMOD5=mod_wrap2:mod_wrap:mod_wrap2_file:mod_wrap2_sql:mod_copy:mod_deflate:mod_gss:mod_auth_gss
SMOD6=mod_sftp:mod_sftp_pam:mod_sftp_sql:mod_tls_shmcache:mod_geoip2

%serverbuild
export CFLAGS="$CFLAGS -DLDAP_DEPRECATED -DUSE_LDAP_TLS -DHAVE_OPENSSL"
export LIBS="-L%{_libdir} -lattr -lsodium"

pushd mod_gss-%{mod_gss_version}
perl -pi -e "s|<gssapi.h>|<gssapi/gssapi.h>|" configure*
perl -pi -e "s|NULL,code|kc,code|" *.in
%configure2_5x --enable-mit
# Workaround a missing dcl in kerberos...
cat >> mod_gss.h <<EOF
#ifndef GSS_C_AF_INET6
#define GSS_C_AF_INET6 24
#endif
EOF
popd

pushd contrib/mod_load
%configure2_5x
popd

pushd contrib/mod_wrap2
%configure2_5x
popd

pushd contrib/mod_vroot
%configure2_5x
popd

pushd contrib/mod_sftp
%configure2_5x
popd


# put extra modules in place 
for i in `find mod_* -type f -name "*.c"` `find mod_* -type f -name "*.h"`; do
    cp $i contrib/
done

%configure2_5x \
	--libexecdir=%{_libdir}/%{name} \
	--enable-auth-pam \
	--enable-cap \
	--disable-facl \
    --enable-largefile \
    --disable-rpath \
    --disable-strip \
	--enable-dso \
	--enable-nls \
	--enable-sodium \
	--enable-openssl \
	--with-lastlog=/var/log/lastlog \
	--enable-ipv6 \
	--enable-shadow \
	--enable-ctrls \
    --with-includes="%{_includedir}/sodium" \
    --with-modules=mod_readme:mod_auth_pam:mod_tls \
    --with-shared=${SMOD1}:${SMOD2}:${SMOD3}:${SMOD4}:${SMOD5}:${SMOD6}:mod_ifsession

# libcap hack
perl -pi -e "s|/lib/libcap|/blabla|g" Make.rules
echo "#define HAVE_LINUX_CAPABILITY_H 1" >> config.h

%make_build

%check

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_libdir}/%{name}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_sysconfdir}/%{name}.d
install -d %{buildroot}%{_sysconfdir}/pam.d
install -d %{buildroot}%{_sysconfdir}/xinetd.d
install -d %{buildroot}%{_sysconfdir}/avahi/services
install -d %{buildroot}/var/ftp/pub
install -d %{buildroot}/var/log/%{name}
install -d %{buildroot}/var/run/%{name}

%makeinstall \
	rundir=/run/%{name} \
	LIBEXECDIR=%{buildroot}%{_libdir}/%{name} \
	SHARED_MODULE_DIRS="" \
	pkgconfigdir=%{buildroot}%{_libdir}/pkgconfig \
    INSTALL_USER=`id -un` INSTALL_GROUP=`id -gn`

# fix borked pkgconfig file
perl -pi -e "s|^prefix.*|prefix=%{_prefix}|g" %{buildroot}%{_libdir}/pkgconfig/*.pc
perl -pi -e "s|/lib/|/%{_lib}/|g" %{buildroot}%{_libdir}/pkgconfig/*.pc

install -m0644 contrib/dist/rpm/ftp.pamd %{buildroot}%{_sysconfdir}/pam.d/%{name}
install -m0755 contrib/xferstats.holger-preiss %{buildroot}%{_sbindir}

%makeinstall -C contrib/mod_wrap2 LIBEXECDIR=%{buildroot}%{_libdir}/%{name}
%makeinstall -C contrib/mod_load LIBEXECDIR=%{buildroot}%{_libdir}/%{name}
%makeinstall -C contrib/mod_sftp LIBEXECDIR=%{buildroot}%{_libdir}/%{name}
%makeinstall -C contrib/mod_vroot LIBEXECDIR=%{buildroot}%{_libdir}/%{name}

install -m0644 PCLinuxOS/proftpd.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -m0644 PCLinuxOS/proftpd.xinetd %{buildroot}%{_sysconfdir}/xinetd.d/%{name}-xinetd
install -m0755 PCLinuxOS/proftpd.init %{buildroot}%{_initrddir}/%{name}
install -m0644 PCLinuxOS/proftpd.service %{buildroot}%{_sysconfdir}/avahi/services/%{name}.service
install -m0644 PCLinuxOS/basic.conf %{buildroot}%{_sysconfdir}/%{name}.conf
install -m0644 PCLinuxOS/welcome.msg %{buildroot}/var/ftp/pub/welcome.msg

install -m0644 %{SOURCE200} %{buildroot}%{_sysconfdir}/proftpd-anonymous.conf
install -m0644 %{SOURCE33} %{buildroot}%{_sysconfdir}/%{name}_mod_tls.conf
install -m0644 %{SOURCE34} %{buildroot}%{_sysconfdir}/%{name}_mod_ban.conf
install -m0644 %{SOURCE35} %{buildroot}%{_sysconfdir}/%{name}.d/35_mod_ban.conf
install -m0644 %{SOURCE37} %{buildroot}%{_sysconfdir}/%{name}.d/26_mod_gss.conf

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
install -m0644 %{SOURCE36} %{buildroot}%{_sysconfdir}/sysconfig/%{name}

ln -snf %{name} %{buildroot}%{_sbindir}/in.%{name}
ln -snf %{name} %{buildroot}%{_sbindir}/in.ftpd

# config
echo "LoadModule mod_ctrls_admin.c" > %{buildroot}%{_sysconfdir}/%{name}.d/10_mod_ctrls_admin.conf
echo "LoadModule mod_tls_shmcache.c" > %{buildroot}%{_sysconfdir}/%{name}.d/11_mod_tls_shmcache.conf
# OpenSSL Cipher Profiles
#sed -i -e '/^[[:space:]]*TLSCipherSuite[[:space:]]*PROFILE=SYSTEM$/d' %{buildroot}%{_sysconfdir}/%{name}.d/11_mod_tls.conf
echo "LoadModule mod_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/12_mod_sql.conf
echo "LoadModule mod_ldap.c" > %{buildroot}%{_sysconfdir}/%{name}.d/13_mod_ldap.conf
echo "LoadModule mod_sql_mysql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/14_mod_sql_mysql.conf
echo "LoadModule mod_sql_postgres.c" > %{buildroot}%{_sysconfdir}/%{name}.d/15_mod_sql_postgres.conf
echo "LoadModule mod_quotatab.c" > %{buildroot}%{_sysconfdir}/%{name}.d/16_mod_quotatab.conf
echo "LoadModule mod_quotatab_file.c" > %{buildroot}%{_sysconfdir}/%{name}.d/17_mod_quotatab_file.conf
echo "LoadModule mod_quotatab_ldap.c" > %{buildroot}%{_sysconfdir}/%{name}.d/18_mod_quotatab_ldap.conf
echo "LoadModule mod_quotatab_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/19_mod_quotatab_sql.conf
echo "LoadModule mod_quotatab_radius.c" > %{buildroot}%{_sysconfdir}/%{name}.d/20_mod_quotatab_radius.conf
echo "LoadModule mod_radius.c" > %{buildroot}%{_sysconfdir}/%{name}.d/20_mod_radius.conf
echo "LoadModule mod_wrap2.c" > %{buildroot}%{_sysconfdir}/%{name}.d/21_mod_wrap2.conf
echo "LoadModule mod_wrap2_file.c" > %{buildroot}%{_sysconfdir}/%{name}.d/22_mod_wrap2_file.conf
echo "LoadModule mod_wrap2_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/23_mod_wrap2_sql.conf
echo "LoadModule mod_rewrite.c" > %{buildroot}%{_sysconfdir}/%{name}.d/24_mod_rewrite.conf
echo "LoadModule mod_ratio.c" > %{buildroot}%{_sysconfdir}/%{name}.d/25_mod_ratio.conf
echo "LoadModule mod_autohost.c" > %{buildroot}%{_sysconfdir}/%{name}.d/27_mod_autohost.conf
echo "LoadModule mod_case.c" > %{buildroot}%{_sysconfdir}/%{name}.d/28_mod_case.conf
echo "LoadModule mod_wrap.c" > %{buildroot}%{_sysconfdir}/%{name}.d/30_mod_wrap.conf
echo "LoadModule mod_load.c" > %{buildroot}%{_sysconfdir}/%{name}.d/31_mod_load.conf
install -m0644 PCLinuxOS/32_mod_shaper.conf %{buildroot}%{_sysconfdir}/%{name}.d/32_mod_shaper.conf
echo "LoadModule mod_site_misc.c" > %{buildroot}%{_sysconfdir}/%{name}.d/33_mod_site_misc.conf
echo "LoadModule mod_vroot.c" > %{buildroot}%{_sysconfdir}/%{name}.d/36_mod_vroot.conf
echo "LoadModule mod_sftp.c" > %{buildroot}%{_sysconfdir}/%{name}.d/37_mod_sftp.conf
echo "LoadModule mod_sftp_pam.c" > %{buildroot}%{_sysconfdir}/%{name}.d/38_mod_sftp_pam.conf
echo "LoadModule mod_sftp_sql.c" > %{buildroot}%{_sysconfdir}/%{name}.d/39_mod_sftp_sql.conf
echo "LoadModule mod_copy.c" > %{buildroot}%{_sysconfdir}/%{name}.d/40_mod_copy.conf
echo "LoadModule mod_deflate.c" > %{buildroot}%{_sysconfdir}/%{name}.d/41_mod_deflate.conf
echo "LoadModule mod_exec.c" > %{buildroot}%{_sysconfdir}/%{name}.d/42_mod_exec.conf
echo "LoadModule mod_sql_passwd.c" > %{buildroot}%{_sysconfdir}/%{name}.d/43_mod_sql_passwd.conf
echo "LoadModule mod_sql_sqlite.c" > %{buildroot}%{_sysconfdir}/%{name}.d/44_mod_sql_sqlite.conf
echo "LoadModule mod_geoip2.c" > %{buildroot}%{_sysconfdir}/%{name}.d/45_mod_geoip2.conf
cat > %{buildroot}%{_sysconfdir}/%{name}.d/99_mod_ifsession.conf << EOF
# keep this module the last one
LoadModule mod_ifsession.c
EOF

cat > README.pclos << EOF
PCLinuxOS RPM specific notes

modules support
---------------
proftpd now loads the modules dynamically, very few modules are compiled
into the proftpd binary. The new configuration file /etc/proftpd.conf uses a
"Include /etc/proftpd.d/*.conf" statement which makes proftpd very similar to
how modules are loaded and the configuration of apache-2.x. Because of this you
may have to manually merge your old configuration into the new
/etc/proftpd.conf file.  This is especially true if you are using LDAP, because
then the mod_ldap.so proftpd module will not be automatically loaded. Here is a
list of the modules that are compiled as DSO's:

 o mod_autohost.so         
 o mod_ban.so              
 o mod_case.so             
 o mod_ctrls_admin.so      
 o mod_ifsession.so
 o mod_ldap.so
 o mod_load.so             
 o mod_quotatab.so         
 o mod_quotatab_file.so    
 o mod_quotatab_ldap.so    
 o mod_quotatab_sql.so     
 o mod_quotatab_radius.so  
 o mod_radius.so
 o mod_ratio.so
 o mod_rewrite.so
 o mod_shaper.so           
 o mod_site_misc.so        
 o mod_sql.so              
 o mod_sql_mysql.so        
 o mod_sql_postgres.so     
 o mod_tls_shmcache.so
 o mod_wrap.so             <- NEW 
 o mod_wrap2.so            <- NEW  
 o mod_wrap2_file.so       <- NEW
 o mod_wrap2_sql.so        <- NEW
 o mod_vroot.so            <- NEW
 o mod_sftp.so             <- NEW
 o mod_sftp_sql.so         <- NEW
 o mod_sftp_pam.so         <- NEW
 o mod_copy.so             <- NEW
 o mod_deflate.so          <- NEW
 o mod_exec.so             <- NEW
 o mod_sql_passwd.so       <- NEW
 o mod_sql_sqlite.so       <- NEW
 o mod_geoip.so            <- NEW
 o mod_auth_gss.so         <- NEW
 o mod_gss.so              <- NEW

 
anonymous access configuration
------------------------------
Starting with 1.3.0-3, there is no proftpd-anonymous package anymore.
As it is just a configuration issue, providing a dedicated package was a bit
overkill. Samples configuration files are available among normal package
documentation. You may have to update your configuration manually.
EOF


%find_lang %{name}

# cleanup
rm -f %{buildroot}%{_libdir}/%{name}/*.{a,la}
rm -f contrib/README.mod_sql contrib/README.linux-privs

%post
%_post_service %{name}

# xinetd reset
# Only do it if xinetd is there. -- Geoff
if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

# ftpusers creation
if [ ! -f %{_sysconfdir}/ftpusers ]; then
    touch %{_sysconfdir}/ftpusers
fi

USERS="root bin daemon adm lp sync shutdown halt mail news uucp operator games nobody"
for i in $USERS ;do
        cat %{_sysconfdir}/ftpusers | grep -q "^$i$" || echo $i >> %{_sysconfdir}/ftpusers
done

%pre
%_pre_useradd ftp /var/ftp /bin/false

%postun
%_postun_userdel ftp

%preun
%_preun_service %{name}
if [ "$1" = 0 ]; then
 if [ -d /var/run/%{name} ]; then
  rm -rf /var/run/%{name}/*
 fi
fi

if [ -x /usr/sbin/xinetd ];then
%_post_service xinetd
fi

%post -n %{name}-mod_autohost
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_autohost
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_case
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_case
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ctrls_admin
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ctrls_admin
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_gss
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_gss
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ifsession
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ifsession
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ldap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ldap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_load
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_load
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_file
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_file
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_ldap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_ldap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_quotatab_radius
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_quotatab_radius
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_radius
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_radius
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ratio
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ratio
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_rewrite
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_rewrite
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_shaper
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_shaper
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_site_misc
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_site_misc
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql_mysql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql_mysql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_tls_shmcache
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_tls_shmcache
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap2_file
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap2_file
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap2
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap2
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_wrap2_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_wrap2_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_ban
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_ban
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_vroot
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_vroot
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sftp
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sftp
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sftp_pam
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sftp_pam
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sftp_sql
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sftp_sql
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_copy
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_copy
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_deflate
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_deflate
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_exec
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_exec
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql_passwd
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql_passwd
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%post -n %{name}-mod_sql_sqlite
service proftpd condrestart > /dev/null 2>/dev/null || :
    
%preun -n %{name}-mod_sql_sqlite
if [ "$1" = 0 ]; then
    service proftpd condrestart > /dev/null 2>/dev/null || :
fi

%triggerpostun -- proftpd-anonymous
# this package doesn't exist anymore, but its configuration file may
# be used in current proftpd configuration
if [ -e /etc/proftpd-anonymous.conf.rpmsave ]; then
    mv -f /etc/proftpd-anonymous.conf.rpmsave /etc/proftpd-anonymous.conf
    echo "warning: /etc/proftpd-anonymous.conf.rpmsave restored as /etc/proftpd-anonymous.conf"
fi

%clean
rm -rf %{buildroot}

%files -f %{name}.lang
%defattr(-,root,root)
%doc README* INSTALL NEWS CREDITS COPYING doc/* README.pclos
%doc sample-configurations/*
%dir %{_sysconfdir}/proftpd.d
%config(noreplace) %{_sysconfdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}-anonymous.conf
%config(noreplace) %{_sysconfdir}/%{name}_mod_tls.conf
%config(noreplace) %{_sysconfdir}/%{name}_mod_ban.conf
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/pam.d/%{name}
%config(noreplace) %{_sysconfdir}/xinetd.d/%{name}-xinetd
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/avahi/services/%{name}.service
%{_initrddir}/%{name}
%{_sbindir}/%{name}
%{_sbindir}/ftpscrub
%{_sbindir}/ftpshut
%{_sbindir}/in.ftpd
%{_sbindir}/in.%{name}
%{_sbindir}/xferstats.holger-preiss
%{_bindir}/ftpasswd
%{_bindir}/ftpcount
%{_bindir}/ftpdctl
%{_bindir}/ftpmail
%{_bindir}/ftptop
%{_bindir}/ftpwho
%{_bindir}/ftpquota
%{_bindir}/prxs
%dir %{_libdir}/%{name}
%dir /var/ftp
%dir /var/ftp/pub
%config(noreplace) /var/ftp/pub/welcome.msg
%dir /var/run/%{name}
%dir /var/log/%{name}
%{_mandir}/man*/*

%files devel
%defattr(-,root,root)
%doc ChangeLog
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/Make.rules
%{_includedir}/%{name}/mod_sftp/*.h
%{_libdir}/pkgconfig/*.pc

%files mod_ctrls_admin
%defattr(-,root,root)
%doc doc/contrib/mod_ctrls_admin.html
%config(noreplace) %{_sysconfdir}/%{name}.d/10_mod_ctrls_admin.conf
%{_libdir}/%{name}/mod_ctrls_admin.so

%files mod_ifsession
%defattr(-,root,root)
%doc doc/contrib/mod_ifsession.html
%config(noreplace) %{_sysconfdir}/%{name}.d/99_mod_ifsession.conf
%{_libdir}/%{name}/mod_ifsession.so

%files mod_ldap
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/13_mod_ldap.conf
%{_libdir}/%{name}/mod_ldap.so

%files mod_quotatab
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab.html
%config(noreplace) %{_sysconfdir}/%{name}.d/16_mod_quotatab.conf
%{_libdir}/%{name}/mod_quotatab.so

%files mod_quotatab_file
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_file.html
%config(noreplace) %{_sysconfdir}/%{name}.d/17_mod_quotatab_file.conf
%{_libdir}/%{name}/mod_quotatab_file.so

%files mod_quotatab_ldap
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_ldap.html
%config(noreplace) %{_sysconfdir}/%{name}.d/18_mod_quotatab_ldap.conf
%{_libdir}/%{name}/mod_quotatab_ldap.so

%files mod_quotatab_sql
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/19_mod_quotatab_sql.conf
%{_libdir}/%{name}/mod_quotatab_sql.so

%files mod_quotatab_radius
%defattr(-,root,root)
%doc doc/contrib/mod_quotatab_radius.html
%config(noreplace) %{_sysconfdir}/%{name}.d/20_mod_quotatab_radius.conf
%{_libdir}/%{name}/mod_quotatab_radius.so

%files mod_radius
%defattr(-,root,root)
%doc doc/contrib/mod_radius.html
%config(noreplace) %{_sysconfdir}/%{name}.d/20_mod_radius.conf
%{_libdir}/%{name}/mod_radius.so

%files mod_ratio
%defattr(-,root,root)
%doc contrib/README.ratio
%config(noreplace) %{_sysconfdir}/%{name}.d/25_mod_ratio.conf
%{_libdir}/%{name}/mod_ratio.so

%files mod_rewrite
%defattr(-,root,root)
%doc doc/contrib/mod_rewrite.html
%config(noreplace) %{_sysconfdir}/%{name}.d/24_mod_rewrite.conf
%{_libdir}/%{name}/mod_rewrite.so

%files mod_site_misc
%defattr(-,root,root)
%doc doc/contrib/mod_site_misc.html
%config(noreplace) %{_sysconfdir}/%{name}.d/33_mod_site_misc.conf
%{_libdir}/%{name}/mod_site_misc.so

%files mod_sql
%defattr(-,root,root)
%doc doc/contrib/mod_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/12_mod_sql.conf
%{_libdir}/%{name}/mod_sql.so

%files mod_sql_mysql
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/14_mod_sql_mysql.conf
%{_libdir}/%{name}/mod_sql_mysql.so

%files mod_sql_postgres
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/%{name}.d/15_mod_sql_postgres.conf
%{_libdir}/%{name}/mod_sql_postgres.so

%files mod_tls_shmcache
%defattr(-,root,root)
%doc doc/contrib/mod_tls_shmcache.html
%config(noreplace) %{_sysconfdir}/%{name}.d/11_mod_tls_shmcache.conf
%{_libdir}/%{name}/mod_tls_shmcache.so

%files mod_autohost
%defattr(-,root,root)
%doc mod_autohost/mod_autohost.html
%config(noreplace) %{_sysconfdir}/%{name}.d/27_mod_autohost.conf
%{_libdir}/%{name}/mod_autohost.so

%files mod_case
%defattr(-,root,root)
%doc mod_case/mod_case.html
%config(noreplace) %{_sysconfdir}/%{name}.d/28_mod_case.conf
%{_libdir}/%{name}/mod_case.so

%files mod_gss
%defattr(-,root,root)
%doc mod_gss-*/COPYING mod_gss-*/mod_gss.html mod_gss-*/README.mod_gss mod_gss-*/rfc1509.txt mod_gss-*/rfc2228.txt
%config(noreplace) %{_sysconfdir}/%{name}.d/26_mod_gss.conf
%{_libdir}/%{name}/mod_gss.so
%{_libdir}/%{name}/mod_auth_gss.so

%files mod_load
%defattr(-,root,root)
%doc doc/contrib/mod_load.html
%config(noreplace) %{_sysconfdir}/%{name}.d/31_mod_load.conf
%{_libdir}/%{name}/mod_load.so

%files mod_shaper
%defattr(-,root,root)
%doc doc/contrib/mod_shaper.html
%config(noreplace) %{_sysconfdir}/%{name}.d/32_mod_shaper.conf
%{_libdir}/%{name}/mod_shaper.so

%files mod_wrap2
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2.html
%config(noreplace) %{_sysconfdir}/%{name}.d/21_mod_wrap2.conf
%{_libdir}/%{name}/mod_wrap2.so

%files mod_wrap
%defattr(-,root,root)
%doc doc/contrib/mod_wrap.html
%config(noreplace) %{_sysconfdir}/%{name}.d/30_mod_wrap.conf
%{_libdir}/%{name}/mod_wrap.so

%files mod_wrap2_file
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2_file.html
%config(noreplace) %{_sysconfdir}/%{name}.d/22_mod_wrap2_file.conf
%{_libdir}/%{name}/mod_wrap2_file.so

%files mod_wrap2_sql
%defattr(-,root,root)
%doc doc/contrib/mod_wrap2_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/23_mod_wrap2_sql.conf
%{_libdir}/%{name}/mod_wrap2_sql.so

%files mod_ban
%defattr(-,root,root)
%doc doc/contrib/mod_ban.html
%config(noreplace) %{_sysconfdir}/%{name}.d/35_mod_ban.conf
%{_libdir}/%{name}/mod_ban.so

%files mod_vroot
%defattr(-,root,root)
%doc contrib/mod_vroot/mod_vroot.html
%config(noreplace) %{_sysconfdir}/%{name}.d/36_mod_vroot.conf
%{_libdir}/%{name}/mod_vroot.so

%files mod_sftp
%defattr(-,root,root)
%doc doc/contrib/mod_sftp.html
%config(noreplace) %{_sysconfdir}/%{name}.d/37_mod_sftp.conf
%config(noreplace) %{_sysconfdir}/blacklist.dat
%config(noreplace) %{_sysconfdir}/dhparams.pem
%{_libdir}/%{name}/mod_sftp.so

%files mod_sftp_pam
%defattr(-,root,root)
%doc doc/contrib/mod_sftp_pam.html
%config(noreplace) %{_sysconfdir}/%{name}.d/38_mod_sftp_pam.conf
%{_libdir}/%{name}/mod_sftp_pam.so

%files mod_sftp_sql
%defattr(-,root,root)
%doc doc/contrib/mod_sftp_sql.html
%config(noreplace) %{_sysconfdir}/%{name}.d/39_mod_sftp_sql.conf
%{_libdir}/%{name}/mod_sftp_sql.so

%files mod_copy
%defattr(-,root,root)
%doc doc/contrib/mod_copy.html
%config(noreplace) %{_sysconfdir}/%{name}.d/40_mod_copy.conf
%{_libdir}/%{name}/mod_copy.so

%files mod_deflate
%defattr(-,root,root)
%doc doc/contrib/mod_deflate.html
%config(noreplace) %{_sysconfdir}/%{name}.d/41_mod_deflate.conf
%{_libdir}/%{name}/mod_deflate.so

%files mod_exec
%defattr(-,root,root)
%doc doc/contrib/mod_exec.html
%config(noreplace) %{_sysconfdir}/%{name}.d/42_mod_exec.conf
%{_libdir}/%{name}/mod_exec.so

%files mod_sql_passwd
%defattr(-,root,root)
%doc doc/contrib/mod_sql_passwd.html
%config(noreplace) %{_sysconfdir}/%{name}.d/43_mod_sql_passwd.conf
%{_libdir}/%{name}/mod_sql_passwd.so

%files mod_sql_sqlite
%defattr(-,root,root)
%doc doc/contrib/mod_sql_sqlite.html
%config(noreplace) %{_sysconfdir}/%{name}.d/44_mod_sql_sqlite.conf
%{_libdir}/%{name}/mod_sql_sqlite.so

%files mod_geoip2
%defattr(-,root,root)
%doc mod_geoip2/mod_geoip2.html
%config(noreplace) %{_sysconfdir}/%{name}.d/45_mod_geoip2.conf
%{_libdir}/%{name}/mod_geoip2.so

%changelog
* Mon Dec 04 2023 yodelu - 1.3.8a-1pclos2023
- new version

